Merge branch 'yd/doc-is-in-asciidoc' into maint
[git/mingw.git] / git-pull.sh
blob266e682f6c518ab72dc710d52ed4f1dbe22881b5
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and merge it/them into the current HEAD.'
9 SUBDIRECTORY_OK=Yes
10 OPTIONS_SPEC=
11 . git-sh-setup
12 . git-sh-i18n
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
15 cd_to_toplevel
18 die_conflict () {
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution, or use 'git commit -a'.")"
24 else
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
29 die_merge () {
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
33 else
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
42 log_arg= verbosity= progress= recurse_submodules=
43 merge_args= edit=
44 curr_branch=$(git symbolic-ref -q HEAD)
45 curr_branch_short="${curr_branch#refs/heads/}"
46 rebase=$(git config --bool branch.$curr_branch_short.rebase)
47 if test -z "$rebase"
48 then
49 rebase=$(git config --bool pull.rebase)
51 dry_run=
52 while :
54 case "$1" in
55 -q|--quiet)
56 verbosity="$verbosity -q" ;;
57 -v|--verbose)
58 verbosity="$verbosity -v" ;;
59 --progress)
60 progress=--progress ;;
61 --no-progress)
62 progress=--no-progress ;;
63 -n|--no-stat|--no-summary)
64 diffstat=--no-stat ;;
65 --stat|--summary)
66 diffstat=--stat ;;
67 --log|--no-log)
68 log_arg=$1 ;;
69 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
70 no_commit=--no-commit ;;
71 --c|--co|--com|--comm|--commi|--commit)
72 no_commit=--commit ;;
73 -e|--edit)
74 edit=--edit ;;
75 --no-edit)
76 edit=--no-edit ;;
77 --sq|--squ|--squa|--squas|--squash)
78 squash=--squash ;;
79 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
80 squash=--no-squash ;;
81 --ff)
82 no_ff=--ff ;;
83 --no-ff)
84 no_ff=--no-ff ;;
85 --ff-only)
86 ff_only=--ff-only ;;
87 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
88 --strateg=*|--strategy=*|\
89 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
90 case "$#,$1" in
91 *,*=*)
92 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
93 1,*)
94 usage ;;
96 strategy="$2"
97 shift ;;
98 esac
99 strategy_args="${strategy_args}-s $strategy "
101 -X*)
102 case "$#,$1" in
103 1,-X)
104 usage ;;
105 *,-X)
106 xx="-X $(git rev-parse --sq-quote "$2")"
107 shift ;;
108 *,*)
109 xx=$(git rev-parse --sq-quote "$1") ;;
110 esac
111 merge_args="$merge_args$xx "
113 -r|--r|--re|--reb|--reba|--rebas|--rebase)
114 rebase=true
116 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
117 rebase=false
119 --recurse-submodules)
120 recurse_submodules=--recurse-submodules
122 --recurse-submodules=*)
123 recurse_submodules="$1"
125 --no-recurse-submodules)
126 recurse_submodules=--no-recurse-submodules
128 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
129 dry_run=--dry-run
131 -h|--help-all)
132 usage
135 # Pass thru anything that may be meant for fetch.
136 break
138 esac
139 shift
140 done
142 error_on_no_merge_candidates () {
143 exec >&2
144 for opt
146 case "$opt" in
147 -t|--t|--ta|--tag|--tags)
148 echo "Fetching tags only, you probably meant:"
149 echo " git fetch --tags"
150 exit 1
151 esac
152 done
154 if test true = "$rebase"
155 then
156 op_type=rebase
157 op_prep=against
158 else
159 op_type=merge
160 op_prep=with
163 curr_branch=${curr_branch#refs/heads/}
164 upstream=$(git config "branch.$curr_branch.merge")
165 remote=$(git config "branch.$curr_branch.remote")
167 if [ $# -gt 1 ]; then
168 if [ "$rebase" = true ]; then
169 printf "There is no candidate for rebasing against "
170 else
171 printf "There are no candidates for merging "
173 echo "among the refs that you just fetched."
174 echo "Generally this means that you provided a wildcard refspec which had no"
175 echo "matches on the remote end."
176 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
177 echo "You asked to pull from the remote '$1', but did not specify"
178 echo "a branch. Because this is not the default configured remote"
179 echo "for your current branch, you must specify a branch on the command line."
180 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
181 . git-parse-remote
182 error_on_missing_default_upstream "pull" $op_type $op_prep \
183 "git pull <remote> <branch>"
184 else
185 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
186 echo "from the remote, but no such ref was fetched."
188 exit 1
191 test true = "$rebase" && {
192 if ! git rev-parse -q --verify HEAD >/dev/null
193 then
194 # On an unborn branch
195 if test -f "$GIT_DIR/index"
196 then
197 die "$(gettext "updating an unborn branch with changes added to the index")"
199 else
200 require_clean_work_tree "pull with rebase" "Please commit or stash them."
202 oldremoteref= &&
203 test -n "$curr_branch" &&
204 . git-parse-remote &&
205 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
206 oldremoteref="$(git rev-parse -q --verify "$remoteref")" &&
207 for reflog in $(git rev-list -g $remoteref 2>/dev/null)
209 if test "$reflog" = "$(git merge-base $reflog $curr_branch)"
210 then
211 oldremoteref="$reflog"
212 break
214 done
216 orig_head=$(git rev-parse -q --verify HEAD)
217 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
218 test -z "$dry_run" || exit 0
220 curr_head=$(git rev-parse -q --verify HEAD)
221 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
222 then
223 # The fetch involved updating the current branch.
225 # The working tree and the index file is still based on the
226 # $orig_head commit, but we are merging into $curr_head.
227 # First update the working tree to match $curr_head.
229 eval_gettextln "Warning: fetch updated the current branch head.
230 Warning: fast-forwarding your working tree from
231 Warning: commit \$orig_head." >&2
232 git update-index -q --refresh
233 git read-tree -u -m "$orig_head" "$curr_head" ||
234 die "$(eval_gettext "Cannot fast-forward your working tree.
235 After making sure that you saved anything precious from
236 $ git diff \$orig_head
237 output, run
238 $ git reset --hard
239 to recover.")"
243 merge_head=$(sed -e '/ not-for-merge /d' \
244 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
245 tr '\012' ' ')
247 case "$merge_head" in
249 error_on_no_merge_candidates "$@"
251 ?*' '?*)
252 if test -z "$orig_head"
253 then
254 die "$(gettext "Cannot merge multiple branches into empty head")"
256 if test true = "$rebase"
257 then
258 die "$(gettext "Cannot rebase onto multiple branches")"
261 esac
263 if test -z "$orig_head"
264 then
265 git update-ref -m "initial pull" HEAD $merge_head "$curr_head" &&
266 git read-tree -m -u HEAD || exit 1
267 exit
270 if test true = "$rebase"
271 then
272 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
273 if test "$oldremoteref" = "$o"
274 then
275 unset oldremoteref
279 merge_name=$(git fmt-merge-msg $log_arg <"$GIT_DIR/FETCH_HEAD") || exit
280 case "$rebase" in
281 true)
282 eval="git-rebase $diffstat $strategy_args $merge_args"
283 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
286 eval="git-merge $diffstat $no_commit $edit $squash $no_ff $ff_only"
287 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
288 eval="$eval \"\$merge_name\" HEAD $merge_head"
290 esac
291 eval "exec $eval"